# SmallMapWindow Class Reference

Class managing the smallmap window. More...

Inheritance diagram for SmallMapWindow:

## Public Member Functions
| SmallMapWindow (const WindowDesc *desc, int window_number)
uint | GetMaxLegendHeight () const
| Compute maximal required height of the legends.
uint | GetMinLegendWidth () const
| Compute minimal required width of the legends.
uint | GetNumberColumnsLegend (uint width) const
| Return number of columns that can be displayed in width pixels.
uint | GetLegendHeight (uint width) const
| Compute height given a width.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnTick ()
| Called once per (game) tick.
void | SetNewScroll (int sx, int sy, int sub)
| Set new scroll_x, scroll_y, and subscroll values after limiting them such that the center of the smallmap always contains a part of the map.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
void | SmallMapCenterOnCurrentPos ()
## Private Types
enum | SmallMapType { SMT_CONTOUR, SMT_VEHICLES, SMT_INDUSTRY, SMT_ROUTES, SMT_VEGETATION, SMT_OWNER }
| Types of legends in the SM_WIDGET_LEGEND widget. More...
enum | ZoomLevelChange { ZLC_INITIALIZE, ZLC_ZOOM_OUT, ZLC_ZOOM_IN }
| Available kinds of zoomlevel changes. More...
## Private Member Functions
FORCEINLINE Point | RemapTile (int tile_x, int tile_y) const
| Remap tile to location on this smallmap.
FORCEINLINE Point | PixelToTile (int px, int py, int *sub, bool add_sub=true) const
| Determine the tile relative to the base tile of the smallmap, and the pixel position at that tile for a point in the smallmap.
Point | ComputeScroll (int tx, int ty, int x, int y, int *sub)
| Compute base parameters of the smallmap such that tile (tx, ty) starts at pixel (x, y).
void | SetZoomLevel (ZoomLevelChange change, const Point *zoom_pt)
| Initialize or change the zoom level.
uint32 | GetTileColours (const TileArea &ta) const
| Decide which colours to show to the user for a group of tiles.
void | DrawSmallMapColumn (void *dst, uint xc, uint yc, int pitch, int reps, int start_pos, int end_pos, Blitter *blitter) const
| Draws one column of tiles of the small map in a certain mode onto the screen buffer, skipping the shifted rows in between.
void | DrawVehicles (const DrawPixelInfo *dpi, Blitter *blitter) const
| Adds vehicles to the smallmap.
void | DrawTowns (const DrawPixelInfo *dpi) const
| Adds town names to the smallmap.
void | DrawMapIndicators () const
| Adds map indicators to the smallmap.
void | DrawSmallMap (DrawPixelInfo *dpi) const
| Draws the small map.
## Static Private Member Functions
static void | DrawVertMapIndicator (int x, int y, int y2)
| Draws vertical part of map indicator.
static void | DrawHorizMapIndicator (int x, int x2, int y)
| Draws horizontal part of map indicator.
## Private Attributes
uint | min_number_of_columns
| Minimal number of columns in legends.
uint | min_number_of_fixed_rows
| Minimal number of rows in the legends for the fixed layouts only (all except SMT_INDUSTRY).
uint | column_width
| Width of a column in the SM_WIDGET_LEGEND widget.
int32 | scroll_x
| Horizontal world coordinate of the base tile left of the top-left corner of the smallmap display.
int32 | scroll_y
| Vertical world coordinate of the base tile left of the top-left corner of the smallmap display.
int32 | subscroll
| Number of pixels (0..3) between the right end of the base tile and the pixel at the top-left corner of the smallmap display.
int | zoom
| Zoom level. Bigger number means more zoom-out (further away).
uint8 | refresh
| refresh counter, zeroed every FORCE_REFRESH_PERIOD ticks
## Static Private Attributes
static SmallMapType | map_type = SMT_CONTOUR
| Currently displayed legends.
static bool | show_towns = true
| Display town names in the smallmap.
static const uint | LEGEND_BLOB_WIDTH = 8
| Width of the coloured blob in front of a line text in the SM_WIDGET_LEGEND widget.
static const uint | INDUSTRY_MIN_NUMBER_OF_COLUMNS = 2
| Minimal number of columns in the SM_WIDGET_LEGEND widget for the SMT_INDUSTRY legend.
static const uint8 | FORCE_REFRESH_PERIOD = 0x1F
| map is redrawn after that many ticks

## Detailed Description

Class managing the smallmap window.

Definition at line 510 of file smallmap_gui.cpp.

## Member Enumeration Documentation

enum SmallMapWindow::SmallMapType`[private]`

Types of legends in the SM_WIDGET_LEGEND widget.

Definition at line 512 of file smallmap_gui.cpp.

enum SmallMapWindow::ZoomLevelChange`[private]`

Available kinds of zoomlevel changes.

Enumerator:

  ZLC_INITIALIZE | Initialize zoom level.
  ZLC_ZOOM_OUT | Zoom out.
  ZLC_ZOOM_IN | Zoom in.

Definition at line 522 of file smallmap_gui.cpp.

## Member Function Documentation

Point SmallMapWindow::ComputeScroll | ( | int | tx,
|  | int | ty,
|  | int | x,
|  | int | y,
|  | int * | sub |
| ) |  |  | `[inline, private]`

Compute base parameters of the smallmap such that tile (tx, ty) starts at pixel (x, y).

Parameters:

  | tx | Tile x coordinate.
  | ty | Tile y coordinate.
  | x | Non-negative horizontal position in the display where the tile starts.
  | y | Non-negative vertical position in the display where the tile starts.
  | sub | [out] Value of subscroll needed.

Returns:
  scroll_x, scroll_y values.

Definition at line 607 of file smallmap_gui.cpp.

References PixelToTile(), TILE_SIZE, and zoom.

static void SmallMapWindow::DrawHorizMapIndicator | ( | int | x,
|  | int | x2,
|  | int | y |
| ) |  |  | `[inline, static, private]`

Draws horizontal part of map indicator.

Parameters:

  | x | X coord of left border of main viewport
  | x2 | X coord of right border of main viewport
  | y | Y coord of top/bottom border of main viewport

Definition at line 850 of file smallmap_gui.cpp.

References GfxFillRect().

Referenced by DrawMapIndicators().

void SmallMapWindow::DrawSmallMap | ( | DrawPixelInfo * | dpi | ) | const`[inline, private]`

Draws the small map.

Basically, the small map is draw column of pixels by column of pixels. The pixels are drawn directly into the screen buffer. The final map is drawn in multiple passes. The passes are:

1. The colours of tiles in the different modes.
2. Town names (optional)

Parameters:

  | dpi | pointer to pixel to write onto

Definition at line 890 of file smallmap_gui.cpp.

References _colour_gradient, _settings_client, SmallMapColourScheme::default_colour, DrawMapIndicators(), DrawSmallMapColumn(), DrawTowns(), DrawVehicles(), BlitterFactoryBase::GetCurrentBlitter(), GfxFillRect(), ClientSettings::gui, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, map_type, min(), Blitter::MoveTo(), OWNER_END, OWNER_NONE, OWNER_TOWN, OWNER_WATER, PixelToTile(), scroll_x, scroll_y, show_towns, GUISettings::smallmap_land_colour, TILE_SIZE, and zoom.

Referenced by DrawWidget().

void SmallMapWindow::DrawSmallMapColumn | ( | void * | dst,
|  | uint | xc,
|  | uint | yc,
|  | int | pitch,
|  | int | reps,
|  | int | start_pos,
|  | int | end_pos,
|  | Blitter * | blitter |
| ) |  |  | const`[inline, private]`

Draws one column of tiles of the small map in a certain mode onto the screen buffer, skipping the shifted rows in between.

Parameters:

  | dst | Pointer to a part of the screen buffer to write to.
  | xc | The X coordinate of the first tile in the column.
  | yc | The Y coordinate of the first tile in the column
  | pitch | Number of pixels to advance in the screen buffer each time a pixel is written.
  | reps | Number of lines to draw
  | start_pos | Position of first pixel to draw.
  | end_pos | Position of last pixel to draw (exclusive).
  | blitter | current blitter

Note:
  If pixel position is below `0`, skip drawing.

See also:
  GetSmallMapPixels(TileIndex)

Definition at line 732 of file smallmap_gui.cpp.

References _settings_game, TileArea::ClampToMap(), GameSettings::construction, ConstructionSettings::freeform_edges, GetTileColours(), MapMaxX(), MapMaxY(), max(), Blitter::MoveTo(), Blitter::SetPixel(), TileXY(), and zoom.

Referenced by DrawSmallMap().

void SmallMapWindow::DrawTowns | ( | const DrawPixelInfo * | dpi | ) | const`[inline, private]`

Adds town names to the smallmap.

Parameters:

  | dpi | the part of the smallmap to be drawn into

Definition at line 811 of file smallmap_gui.cpp.

References DrawString(), FONT_HEIGHT_SMALL, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Window::left, RemapTile(), SetDParam(), subscroll, TileX(), TileY(), Window::top, and ViewportSign::width_small.

Referenced by DrawSmallMap().

void SmallMapWindow::DrawVehicles | ( | const DrawPixelInfo * | dpi,
|  | Blitter * | blitter |
| ) |  |  | const`[inline, private]`

Adds vehicles to the smallmap.

Parameters:

  | dpi | the part of the smallmap to be drawn into
  | blitter | current blitter

Definition at line 772 of file smallmap_gui.cpp.

References IsInsideMM(), map_type, RemapTile(), Blitter::SetPixel(), subscroll, TILE_SIZE, BaseVehicle::type, VEH_EFFECT, and Vehicle::vehstatus.

Referenced by DrawSmallMap().

static void SmallMapWindow::DrawVertMapIndicator | ( | int | x,
|  | int | y,
|  | int | y2 |
| ) |  |  | `[inline, static, private]`

Draws vertical part of map indicator.

Parameters:

  | x | X coord of left/right border of main viewport
  | y | Y coord of top border of main viewport
  | y2 | Y coord of bottom border of main viewport

Definition at line 838 of file smallmap_gui.cpp.

References GfxFillRect().

Referenced by DrawMapIndicators().

virtual void SmallMapWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1058 of file smallmap_gui.cpp.

References _dynlang, _industry_counts, _smallmap_industry_count, column_width, DrawSmallMap(), DrawString(), LegendAndColour::end, FillDrawPixelInfo(), FONT_HEIGHT_SMALL, GetNumberColumnsLegend(), GfxFillRect(), LEGEND_BLOB_WIDTH, map_type, max(), min_number_of_fixed_rows, NUM_INDUSTRYTYPES, SetDParam(), SM_WIDGET_LEGEND, SM_WIDGET_MAP, TD_RTL, DynamicLanguages::text_dir, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

uint SmallMapWindow::GetLegendHeight | ( | uint | width | ) | const`[inline]`

Compute height given a width.

Returns:
  Needed height for displaying the smallmap legends in pixels.

Definition at line 1009 of file smallmap_gui.cpp.

References _smallmap_industry_count, FONT_HEIGHT_SMALL, GetNumberColumnsLegend(), max(), min_number_of_fixed_rows, WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

uint SmallMapWindow::GetMaxLegendHeight | ( |  | ) | const`[inline]`

Compute maximal required height of the legends.

Returns:
  Maximally needed height for displaying the smallmap legends in pixels.

Definition at line 984 of file smallmap_gui.cpp.

References _smallmap_industry_count, FONT_HEIGHT_SMALL, max(), min_number_of_columns, min_number_of_fixed_rows, WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

uint SmallMapWindow::GetMinLegendWidth | ( |  | ) | const`[inline]`

Compute minimal required width of the legends.

Returns:
  Minimally needed width for displaying the smallmap legends in pixels.

Definition at line 993 of file smallmap_gui.cpp.

References column_width, min_number_of_columns, and WD_FRAMERECT_LEFT.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

uint SmallMapWindow::GetNumberColumnsLegend | ( | uint | width | ) | const`[inline]`

Return number of columns that can be displayed in width pixels.

Returns:
  Number of columns to display.

Definition at line 1001 of file smallmap_gui.cpp.

References column_width.

Referenced by DrawWidget(), GetLegendHeight(), and OnClick().

uint32 SmallMapWindow::GetTileColours | ( | const TileArea & | ta | ) | const`[inline, private]`

Decide which colours to show to the user for a group of tiles.

Parameters:

  | ta | Tile area to investigate.

Returns:
  Colours to display.

Definition at line 680 of file smallmap_gui.cpp.

References GetSmallMapContoursPixels(), GetSmallMapIndustriesPixels(), GetSmallMapOwnerPixels(), GetSmallMapRoutesPixels(), GetSmallMapVegetationPixels(), GetSmallMapVehiclesPixels(), INVALID_TILE, map_type, MP_VOID, and TILE_AREA_LOOP.

Referenced by DrawSmallMapColumn().

virtual void SmallMapWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1123 of file smallmap_gui.cpp.

References _dynlang, _left_button_clicked, _smallmap_industry_count, _smallmap_industry_show_heightmap, column_width, NWidgetBase::current_x, NWidgetBase::current_y, FindWindowById(), FONT_HEIGHT_SMALL, GetNumberColumnsLegend(), Window::HandleButtonClick(), INVALID_VEHICLE, Window::LowerWidget(), map_type, max(), min_number_of_fixed_rows, PixelToTile(), NWidgetBase::pos_x, NWidgetBase::pos_y, Window::RaiseWidget(), RemapCoords(), scroll_x, Window::SetDirty(), Window::SetWidgetLoweredState(), SetZoomLevel(), LegendAndColour::show_on_map, show_towns, SM_WIDGET_CENTERMAP, SM_WIDGET_CONTOUR, SM_WIDGET_DISABLEINDUSTRIES, SM_WIDGET_ENABLEINDUSTRIES, SM_WIDGET_INDUSTRIES, SM_WIDGET_LEGEND, SM_WIDGET_MAP, SM_WIDGET_OWNERS, SM_WIDGET_ROUTES, SM_WIDGET_SELECTINDUSTRIES, SM_WIDGET_SHOW_HEIGHT, SM_WIDGET_TOGGLETOWNNAME, SM_WIDGET_VEGETATION, SM_WIDGET_VEHICLES, SM_WIDGET_ZOOM_IN, SM_WIDGET_ZOOM_OUT, TD_RTL, DynamicLanguages::text_dir, TILE_SIZE, WD_FRAMERECT_LEFT, WD_FRAMERECT_TOP, ZLC_ZOOM_IN, and ZLC_ZOOM_OUT.

virtual void SmallMapWindow::OnInit | ( |  | ) | `[inline, virtual]`

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note:
  nested_root and/or nested_array (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 1025 of file smallmap_gui.cpp.

References column_width, LegendAndColour::end, GetStringBoundingBox(), Window::height, INDUSTRY_MIN_NUMBER_OF_COLUMNS, LEGEND_BLOB_WIDTH, lengthof, max(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::MAX_SIZE, min_number_of_columns, min_number_of_fixed_rows, SetDParam(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and Window::width.

virtual void SmallMapWindow::OnMouseWheel | ( | int | wheel | ) | `[inline, virtual]`

The mouse wheel has been turned.

Parameters:

  | wheel | the amount of movement of the mouse wheel.

Reimplemented from Window.

Definition at line 1255 of file smallmap_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, IsInsideMM(), Window::left, NWidgetBase::pos_x, NWidgetBase::pos_y, SetZoomLevel(), SM_WIDGET_MAP, Window::top, ZLC_ZOOM_IN, and ZLC_ZOOM_OUT.

virtual void SmallMapWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1118 of file smallmap_gui.cpp.

References Window::DrawWidgets().

virtual void SmallMapWindow::OnRightClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the right mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented from Window.

Definition at line 1247 of file smallmap_gui.cpp.

References SM_WIDGET_MAP.

virtual void SmallMapWindow::OnScroll | ( | Point | delta | ) | `[inline, virtual]`

Handle the request for (viewport) scrolling.

Parameters:

  | delta | the amount the viewport must be scrolled.

Reimplemented from Window.

Definition at line 1311 of file smallmap_gui.cpp.

References CursorVars::fix_at, PixelToTile(), scroll_x, Window::SetDirty(), SetNewScroll(), and TILE_SIZE.

FORCEINLINE Point SmallMapWindow::PixelToTile | ( | int | px,
|  | int | py,
|  | int * | sub,
|  | bool | add_sub = `true` |
| ) |  |  | const`[inline, private]`

Determine the tile relative to the base tile of the smallmap, and the pixel position at that tile for a point in the smallmap.

Parameters:

  | px | Horizontal coordinate of the pixel.
  | py | Vertical coordinate of the pixel.
  | sub[out] | Pixel position at the tile (0..3).
  | add_sub | Add current subscroll to the position.

Returns:
  Tile being displayed at the given position relative to scroll_x and scroll_y.

Note:
  The subscroll offset is already accounted for.

Definition at line 575 of file smallmap_gui.cpp.

References subscroll, and zoom.

Referenced by ComputeScroll(), DrawSmallMap(), OnClick(), OnScroll(), and SetZoomLevel().

FORCEINLINE Point SmallMapWindow::RemapTile | ( | int | tile_x,
|  | int | tile_y |
| ) |  |  | const`[inline, private]`

Remap tile to location on this smallmap.

Parameters:

  | tile_x | X coordinate of the tile.
  | tile_y | Y coordinate of the tile.

Returns:
  Position to draw on.

Definition at line 551 of file smallmap_gui.cpp.

References RemapCoords(), scroll_x, scroll_y, TILE_SIZE, and zoom.

Referenced by DrawMapIndicators(), DrawTowns(), and DrawVehicles().

void SmallMapWindow::SetNewScroll | ( | int | sx,
|  | int | sy,
|  | int | sub |
| ) |  |  | `[inline]`

Set new scroll_x, scroll_y, and subscroll values after limiting them such that the center of the smallmap always contains a part of the map.

Parameters:

  | sx | Proposed new scroll_x
  | sy | Proposed new scroll_y
  | sub | Proposed new subscroll

Definition at line 1282 of file smallmap_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, InverseRemapCoords(), MapMaxX(), MapMaxY(), scroll_x, scroll_y, SM_WIDGET_MAP, subscroll, TILE_SIZE, and zoom.

Referenced by OnScroll(), and SetZoomLevel().

virtual void SmallMapWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 1016 of file smallmap_gui.cpp.

References map_type, SetDParam(), and SM_WIDGET_CAPTION.

void SmallMapWindow::SetZoomLevel | ( | ZoomLevelChange | change,
|  | const Point * | zoom_pt |
| ) |  |  | `[inline, private]`

Initialize or change the zoom level.

Parameters:

  | change | Way to change the zoom level.
  | zoom_pt | Position to keep fixed while zooming.

Precondition:
  `*zoom_pt` should contain a point in the smallmap display when zooming in or out.

Definition at line 634 of file smallmap_gui.cpp.

References Clamp(), lengthof, PixelToTile(), scroll_x, Window::SetDirty(), SetNewScroll(), Window::SetWidgetDisabledState(), SM_WIDGET_ZOOM_IN, SM_WIDGET_ZOOM_OUT, TILE_SIZE, ZLC_INITIALIZE, ZLC_ZOOM_IN, ZLC_ZOOM_OUT, and zoom.

Referenced by OnClick(), and OnMouseWheel().

The documentation for this class was generated from the following file:

- src/smallmap_gui.cpp